function [fpred, holdM, holdsigmasq1, holdsigmasq2, holdsigmasq_int] = normal_2D(group, target, ypred, burnin, numbofits, every)

[n, p] = size(target);

lambda_prior = 0.01;
nu = p + 5;
Psi_prior = (nu - p - 1) * cov(target) / 9;
mu0 = mean(target);

group1 = group(:, 1);
group2 = group(:, 2);
ngroup1 = max(group(:, 1));
ngroup2 = max(group(:, 2));
group12 = ngroup2 * (group(:, 1) - 1) + group(:, 2);

mu = 0;

s = mod(1:n, 20) + 1;
v = 0.1 * ones(1, n);

logvsd = log(0.01) * ones(1, n);
logvsd2 = log(0.01);
logJ1sd = log(0.01);
logJ2sd = log(0.01);
logJ12sd = log(0.01);

sum1 = zeros(p, max(s));
sum2 = zeros(p, p, max(s));
numb = zeros(max(s), 1);

for i = 1:n
    sum2(:, :, s(i)) = sum2(:, :, s(i)) + (target(i, :)' * target(i, :));
    sum1(:, s(i)) = sum1(:, s(i)) + target(i, :)';
    numb(s(i)) = numb(s(i)) + 1;
end

Klimit = 10^5;

DCV = 1;

M = 1;
sigmasq1 = 0.1;
sigmasq2 = 0.1;
sigmasq_int = 0.1;

sigmasqnu = 5;

J = gamrnd(numb, 1 / (1 + sum(v)));
beta1 = sqrt(sigmasq1) * randn(length(numb), ngroup1);
beta2 = sqrt(sigmasq2) * randn(length(numb), ngroup2);
beta12 = sqrt(sigmasq_int) * randn(length(numb), ngroup1 * ngroup2);
if ( DCV == 1 )
    sigmasq_loc = 1 ./ gamrnd(sigmasqnu / 2, 2 / sigmasqnu, length(numb), 1);
else
    sigmasq_loc = ones(1, length(numb));
end

a = 8;
b = 0.65;

wstar2 = (b - b * log(b)) / (b - b * log(b) - log(b));

betastar1 = cell(1, n);
betastar2 = cell(1, n);
betastar12 = cell(1, n); 
Jstar = cell(1, n);
fstar = cell(1, n);
gstar = cell(1, n);
newbetastar1 = cell(1, n);
newbetastar2 = cell(1, n);
newbetastar12 = cell(1, n);
newJstar = cell(1, n);
newfstar = cell(1, n);
newgstar = cell(1, n);
logtheta_comp = zeros(1, n);
newlogtheta_comp = zeros(1, n);


K = poissrnd(a * M * v * exp(0.5 * sigmasq1 + 0.5 * sigmasq2 + 0.5 * sigmasq_int) * (b - b * log(b) - log(b)));
sumK = sum(K);
for j1 = 1:n
    betastar1{1, j1} = zeros(K(j1), ngroup1);
    betastar2{1, j1} = zeros(K(j1), ngroup2);
    betastar12{1, j1} = zeros(K(j1), ngroup1 * ngroup2);
    Jstar{1, j1} = zeros(1, K(j1));
    fstar{1, j1} = zeros(1, K(j1));
    gstar{1, j1} = zeros(1, K(j1));
    x2 = zeros(1, K(j1));
    if ( K(j1) == 0 )
        logtheta_comp(j1) = 0;
    else
        betastar1{1, j1} = sqrt(sigmasq1) * randn(K(j1), ngroup1);
        betastar2{1, j1} = sqrt(sigmasq2) * randn(K(j1), ngroup2);
        betastar12{1, j1} = sqrt(sigmasq_int) * randn(K(j1), ngroup1 * ngroup2);

        betastar1{1, j1}(:, group1(j1)) = betastar1{1, j1}(:, group1(j1)) + sigmasq1;
        betastar2{1, j1}(:, group2(j1)) = betastar2{1, j1}(:, group2(j1)) + sigmasq2;
        betastar12{1, j1}(:, group12(j1)) = betastar12{1, j1}(:, group12(j1)) + sigmasq_int;
        
        for k1 = 1:K(j1)
            if ( rand < wstar2 )
                z = - log(b) - 1;
                while ( z < - log(b) )
                    z = gamrnd(2, 1);
                end
                Jstar{1, j1}(k1) = exp(- z);
                gstar{1, j1}(k1) = - log(Jstar{1, j1}(k1));
            else
                Jstar{1, j1}(k1) = b - log(rand);
                gstar{1, j1}(k1) = - log(b) * exp(- (Jstar{1, j1}(k1) - b));
            end
        end
        score1 = betastar1{1, j1}(:, group1) + betastar2{1, j1}(:, group2) + betastar12{1, j1}(:, group12);
        x2 = exp(- Jstar{1, j1} .* (v * exp(score1)'));
        fstar{1, j1} = expint(Jstar{1, j1});
        logtheta_comp(j1) = sum(log(1 - x2.*fstar{1, j1}./(a*gstar{1, j1})));
    end
end
logtheta = sum(logtheta_comp);

logbetasd = log(0.01);
logbeta12sd = log(0.01);
logsigmasq1sd = log(0.01);
logsigmasq2sd = log(0.01);
logsigmasq_intsd = log(0.01);
logMsd = log(0.01);
logsigmasq1sd2 = log(0.01);
logsigmasq2sd2 = log(0.01);
logsigmasq_intsd2 = log(0.01);


mix_aaccept = 0;
mix_acount = 0;
sigmasq1accept = 0;
sigmasq1count = 0;
sigmasq2accept = 0;
sigmasq2count = 0;
sigmasq_intaccept = 0;
sigmasq_intcount = 0;
sigmasq1accept2 = 0;
sigmasq1count2 = 0;
sigmasq2accept2 = 0;
sigmasq2count2 = 0;
sigmasq_intaccept2 = 0;
sigmasq_intcount2 = 0;
betaaccept = 0;
betacount = 0;
beta12accept = 0;
beta12count = 0;
vaccept = zeros(1, n);
vcount = zeros(1, n);
vaccept2 = 0;
vcount2 = 0;
J1accept = 0;
J1count = 0;
J2accept = 0;
J2count = 0;
J12accept = 0;
J12count = 0;
Maccept = 0;
Mcount = 0;


holdsigmasq1 = zeros(1, numbofits);
holdsigmasq2 = zeros(1, numbofits);
holdsigmasq_int = zeros(1, numbofits);
holdphi = zeros(1, numbofits);
holdv = zeros(numbofits, n);
holdM = zeros(1, numbofits);

fpred = zeros(p, size(ypred, 2), ngroup1 * ngroup2);


logmix_asd = log(0.01);

numbclust = zeros(1, numbofits);
for it = 1:(burnin + every * numbofits)
    
    
    if ( mod(it, 10) == 0 )
        %         figure(1)
        %         plot(target, s, '.')
        %         drawnow
        
        disp(['it = ' num2str(it)]);
        disp(['numbclust = ' num2str(length(unique(s)))]);
        disp(['M = ' num2str(M)]);
        disp(['sigmasq1 = ' num2str(sigmasq1)]);
        disp(['sigmasq2 = ' num2str(sigmasq2)]);
        disp(['sigmasq_int = ' num2str(sigmasq_int)]);
        disp(['v = ' num2str(sum(v))]);
        disp(['M accept = ' num2str(Maccept/Mcount)]);
        disp(['J1 accept = ' num2str(J1accept/J1count)]);
        disp(['J2 accept = ' num2str(J2accept/J2count)]);
        disp(['J12 accept = ' num2str(J12accept/J12count)]);
        disp(['sigmasq1 accept = ' num2str(sigmasq1accept/sigmasq1count)]);
        disp(['sigmasq2 accept = ' num2str(sigmasq2accept/sigmasq2count)]);
        disp(['sigmasq_int accept = ' num2str(sigmasq_intaccept/sigmasq_intcount)]);
        disp(['sigmasq1 accept2 = ' num2str(sigmasq1accept2/sigmasq1count2)]);
        disp(['sigmasq2 accept2 = ' num2str(sigmasq2accept2/sigmasq2count2)]);
        disp(['sigmasq_int accept2 = ' num2str(sigmasq_intaccept2/sigmasq_intcount2)]);
        disp(['v accept = ' num2str(min(vaccept./vcount)) ' ' num2str(max(vaccept./vcount))]);
        disp(['beta accept = ' num2str(betaaccept/betacount)]);
        disp(['beta12 accept = ' num2str(beta12accept/beta12count)]);
        disp(['v accept2 = ' num2str(min(vaccept2./vcount2)) ' ' num2str(max(vaccept2./vcount2))]);
        disp(' ');
    end
        
    for i1 = 1:50
        i = ceil(rand * n);
        % Update v
        newv = v;
        newv(i) = v(i) * exp(exp(logvsd(i)) * randn);
        
        K = poissrnd(a * M * newv(i) * exp(0.5 * sigmasq1 + 0.5 * sigmasq2 + 0.5 * sigmasq_int) * (b - b * log(b) - log(b)));
        
        newsumK = sumK + K - length(betastar1{1, i});
        
        if ( newsumK > Klimit )
            accept = 0;
        else
            newbetastar1{1, i} = zeros(K, ngroup1);
            newbetastar2{1, i} = zeros(K, ngroup2);
            newbetastar12{1, i} = zeros(K, ngroup1 * ngroup2);
            newJstar{1, i} = zeros(1, K);
            newfstar{1, i} = zeros(1, K);
            newgstar{1, i} = zeros(1, K);
            x2 = zeros(1, K);
            
            if ( K == 0 )
                newlogtheta_comp(i) = 0;
            else
                newbetastar1{1, i} = sqrt(sigmasq1) * randn(K, ngroup1);
                newbetastar2{1, i} = sqrt(sigmasq2) * randn(K, ngroup2);
                newbetastar12{1, i} = sqrt(sigmasq_int) * randn(K, ngroup1 * ngroup2);

                newbetastar1{1, i}(:, group1(i)) = newbetastar1{1, i}(:, group1(i)) + sigmasq1;
                newbetastar2{1, i}(:, group2(i)) = newbetastar2{1, i}(:, group2(i)) + sigmasq2;
                newbetastar12{1, i}(:, group12(i)) = newbetastar12{1, i}(:, group12(i)) + sigmasq_int;
                
                for k1 = 1:K
                    if ( rand < wstar2 )
                        z = - log(b) - 1;
                        while ( z < - log(b) )
                            z = gamrnd(2, 1);
                        end
                        newJstar{1, i}(k1) = exp(- z);
                        newgstar{1, i}(k1) = - log(newJstar{1, i}(k1));
                    else
                        newJstar{1, i}(k1) = b - log(rand);
                        newgstar{1, i}(k1) = - log(b) * exp(- (newJstar{1, i}(k1) - b));
                    end
                end
                score1 = newbetastar1{1, i}(:, group1) + newbetastar2{1, i}(:, group2) + newbetastar12{1, i}(:, group12);
                x2 = exp(- newJstar{1, i} .* (newv * exp(score1)'));
                newfstar{1, i} = expint(newJstar{1, i});
                
                newlogtheta_comp(i) = sum(log(1 - x2.*newfstar{1, i}./(a*newgstar{1, i})));
            end
            
            for j1 = 1:(i-1)
                K = length(Jstar{1, j1});
                if ( K == 0 )
                    newlogtheta_comp(j1) = 0;
                else
                    score1 = betastar1{1, j1}(:, group1) + betastar2{1, j1}(:, group2) + betastar12{1, j1}(:, group12);
                    x2 = exp(- Jstar{1, j1} .* (newv * exp(score1)'));                    
                    newlogtheta_comp(j1) = sum(log(1 - x2.*fstar{1, j1}./(a*gstar{1, j1})));
                end
            end
            for j1 = (i+1):n
                K = length(Jstar{1, j1});
                if ( K == 0 )
                    newlogtheta_comp(j1) = 0;
                else
                    score1 = betastar1{1, j1}(:, group1) + betastar2{1, j1}(:, group2) + betastar12{1, j1}(:, group12);
                    x2 = exp(- Jstar{1, j1} .* (newv * exp(score1)'));                    
                    newlogtheta_comp(j1) = sum(log(1 - x2.*fstar{1, j1}./(a*gstar{1, j1})));
                end
            end
            
            newlogtheta = sum(newlogtheta_comp);
            
            newloglike = newlogtheta + log(newv(i));
            loglike = logtheta + log(v(i));
            
            score1 = beta1(:, group1) + beta2(:, group2) + beta12(:, group12);
            newloglike = newloglike - sum(J .* (newv * exp(score1)')');
            loglike = loglike - sum(J .* (v * exp(score1)')');
            
            logaccept = newloglike - loglike;
            
            accept = 1;
            if ( (isnan(logaccept) == 1) || (isinf(logaccept)==1) )
                accept = 0;
            elseif ( logaccept < 0 )
                accept = exp(logaccept);
            end
        end
        
        vaccept(i) = vaccept(i) + accept;
        vcount(i) = vcount(i) + 1;
        
        if ( rand < accept )
            v(i) = newv(i);
            logtheta = newlogtheta;
            logtheta_comp = newlogtheta_comp;
            betastar1{1, i} = newbetastar1{1, i};
            betastar2{1, i} = newbetastar2{1, i};
            betastar12{1, i} = newbetastar12{1, i};
            Jstar{1, i} = newJstar{1, i};
            fstar{1, i} = newfstar{1, i};
            gstar{1, i} = newgstar{1, i};
            sumK = newsumK;
        end
        
        if ( isreal(accept) == 0 )
            stop;
        end
        
        logvsd(i) = logvsd(i) + 1 / it^0.55 * (accept - 0.234);
        if ( logvsd(i) > 2 )
            logvsd(i) = 2;
        end
    end
    

    
    for i = 1:n
                
        olds = s(i);
        
        if ( numb(s(i)) == 1 )
            logprob = zeros(1, length(numb));
        else
            logprob = zeros(1, length(numb) + 1);
        end
        
        logprob(1:length(numb)) = log(J) + beta1(:, group1(i)) + beta2(:, group2(i)) + beta12(:, group12(i));
                
        for j = 1:length(numb)
            if ( j ~= s(i) )
                newsum1 = sum1(:, j) + target(i, :)';
                newsum2 = sum2(:, :, j) + target(i, :)' * target(i, :);
                newnumb = numb(j) + 1;
                
                logprob(j) = logprob(j) + 0.5 * p * (log(numb(j) + lambda_prior) - log(newnumb + lambda_prior));
                
                submat1 = (sum1(:, j) + lambda_prior * mu0') * (sum1(:, j) + lambda_prior * mu0')';
                mat1 = Psi_prior + sum2(:, :, j) + lambda_prior * mu0' * mu0 - submat1 / (numb(j) + lambda_prior);
                submat2 = (newsum1 + lambda_prior * mu0') * (newsum1 + lambda_prior * mu0')';
                mat2 = Psi_prior + newsum2 + lambda_prior * mu0' * mu0 - submat2 / (newnumb + lambda_prior);
                
                logprob(j) = logprob(j) + 0.5 * (nu + numb(j)) * log(det(mat1));
                logprob(j) = logprob(j) - 0.5 * (nu + newnumb) * log(det(mat2));
                
                logprob(j) = logprob(j) + sum(gammaln((nu + newnumb + 1 - (1:p)) / 2));
                logprob(j) = logprob(j) - sum(gammaln((nu + numb(j) + 1 - (1:p)) / 2));
            end
        end
        
        if ( numb(s(i)) == 1 )
            score1 = beta1(s(i), group1) + beta2(s(i), group2) + beta12(s(i), group12);
            sump = sum(v .* exp(score1));
            
            logprob(s(i)) = log(M) + score1(i) - log(1 + sump);
                        
            logprob(s(i)) = logprob(s(i)) + 0.5 * p * (log(lambda_prior) - log(1 + lambda_prior));
            
            submat1 = (lambda_prior * mu0') * (lambda_prior * mu0')';
            mat1 = Psi_prior + lambda_prior * mu0' * mu0 - submat1 / lambda_prior;
            submat2 = (sum1(:, s(i)) + lambda_prior * mu0') * (sum1(:, s(i)) + lambda_prior * mu0')';
            mat2 = Psi_prior + sum2(:, :, s(i)) + lambda_prior * mu0' * mu0 - submat2 / (1 + lambda_prior);
            
            logprob(s(i)) = logprob(s(i)) + 0.5 * nu * log(det(mat1));
            logprob(s(i)) = logprob(s(i)) - 0.5 * (nu + 1) * log(det(mat2));
            
            logprob(s(i)) = logprob(s(i)) + sum(gammaln((nu + 1 + 1 - (1:p)) / 2));
            logprob(s(i)) = logprob(s(i)) - sum(gammaln((nu + 1 - (1:p)) / 2));
        else
            newbeta1 = sqrt(sigmasq1) * randn(1, ngroup1);
            newbeta2 = sqrt(sigmasq2) * randn(1, ngroup2);
            newbeta12 = sqrt(sigmasq_int) * randn(1, ngroup1 * ngroup2);
            
            score1 = newbeta1(group1) + newbeta2(group2) + newbeta12(group12);
            sump = sum(v .* exp(score1));

            newJ = gamrnd(1, 1 / (1 + sump));
            if ( DCV == 1 )
                newsigmasq_loc = 1 / gamrnd(sigmasqnu / 2, 2 / sigmasqnu);
            else
                newsigmasq_loc = 1;
            end

            newsum1 = sum1(:, s(i)) - target(i, :)';
            newsum2 = sum2(:, :, s(i)) - target(i, :)' * target(i, :);
            newnumb = numb(s(i)) - 1;
            
            logprob(s(i)) = logprob(s(i)) + 0.5 * p * (log(newnumb + lambda_prior) - log(numb(s(i)) + lambda_prior));
            
            submat1 = (newsum1 + lambda_prior * mu0') * (newsum1 + lambda_prior * mu0')';
            mat1 = Psi_prior + newsum2 + lambda_prior * mu0' * mu0 - submat1 / (newnumb + lambda_prior);
            submat2 = (sum1(:, s(i)) + lambda_prior * mu0') * (sum1(:, s(i)) + lambda_prior * mu0')';
            mat2 = Psi_prior + sum2(:, :, s(i)) + lambda_prior * mu0' * mu0 - submat2 / (numb(s(i)) + lambda_prior);
            
            logprob(s(i)) = logprob(s(i)) + 0.5 * (nu + newnumb) * log(det(mat1));
            logprob(s(i)) = logprob(s(i)) - 0.5 * (nu + numb(j)) * log(det(mat2));
            
            logprob(s(i)) = logprob(s(i)) + sum(gammaln((nu + numb(s(i)) + 1 - (1:p)) / 2));
            logprob(s(i)) = logprob(s(i)) - sum(gammaln((nu + newnumb + 1 - (1:p)) / 2));
                        
            logprob(length(numb) + 1) = log(M) + score1(i) - log(1 + sump);

            newsum1 = target(i, :)';
            newsum2 = target(i, :)' * target(i, :);
            
            logprob(length(numb) + 1) = logprob(length(numb) + 1) + 0.5 * p * (log(lambda_prior) - log(1 + lambda_prior));
            
            submat1 = (lambda_prior * mu0') * (lambda_prior * mu0')';
            mat1 = Psi_prior + lambda_prior * mu0' * mu0 - submat1 / lambda_prior;
            submat2 = (newsum1 + lambda_prior * mu0') * (newsum1 + lambda_prior * mu0')';
            mat2 = Psi_prior + newsum2 + lambda_prior * mu0' * mu0 - submat2 / (1 + lambda_prior);
            
            logprob(length(numb) + 1) = logprob(length(numb) + 1) + 0.5 * nu * log(det(mat1));
            logprob(length(numb) + 1) = logprob(length(numb) + 1) - 0.5 * (nu + 1) * log(det(mat2));
            
            logprob(length(numb) + 1) = logprob(length(numb) + 1) + sum(gammaln((nu + 1 + 1 - (1:p)) / 2));
            logprob(length(numb) + 1) = logprob(length(numb) + 1) - sum(gammaln((nu + 1 - (1:p)) / 2));            
        end
        
        prob = exp(logprob - max(logprob));
        fprob = cumsum(prob);
        fprob = fprob / fprob(end);
        
        u = rand;
        s(i) = 1;
        while ( fprob(s(i)) < u )
            s(i) = s(i) + 1;
        end
        
        sum2(:, :, olds) = sum2(:, :, olds) - target(i, :)' * target(i, :);
        sum1(:, olds) = sum1(:, olds) - target(i, :)';
        numb(olds) = numb(olds) - 1;
        
        if ( s(i) > length(numb) )
            sum2(:, :, size(sum2, 3) + 1) = target(i, :)' * target(i, :);
            sum1(:, size(sum1, 2) + 1) = target(i, :)';
            numb = [numb; 1];
            J = [J; newJ];
            beta1 = [beta1; newbeta1];
            beta2 = [beta2; newbeta2];
            beta12 = [beta12; newbeta12];
            sigmasq_loc = [sigmasq_loc; newsigmasq_loc];
        else
            sum2(:, :, s(i)) = sum2(:, :, s(i)) + target(i, :)' * target(i, :);
            sum1(:, s(i)) = sum1(:, s(i)) + target(i, :)';
            numb(s(i)) = numb(s(i)) + 1;
        end
        if ( numb(olds) == 0 )
            sum2(:, :, olds) = [];
            sum1(:, olds) = [];
            numb = [numb(1:(olds-1)); numb((olds+1):length(numb))];
            J = [J(1:(olds-1)); J((olds+1):length(J))];
            beta1 = [beta1(1:(olds-1), :); beta1((olds+1):size(beta1, 1), :)];
            beta2 = [beta2(1:(olds-1), :); beta2((olds+1):size(beta2, 1), :)];
            beta12 = [beta12(1:(olds-1), :); beta12((olds+1):size(beta12, 1), :)];
            s(s > olds) = s(s > olds) - 1;
            sigmasq_loc(olds) = [];
        end
        
        if ( size(beta1, 1) ~= size(beta12, 1) )
            stop;
        end
    end
    
    
    
    for j = 1:length(numb)
        score1 = beta1(j, group1) + beta2(j, group2) + beta12(j, group12);
        sump = sum(v .* exp(score1));
        J(j) = gamrnd(numb(j), 1 / (1 + sump));
        
        for k = 1:ngroup1
            newbeta1 = beta1(j, :);
            newbeta1(k) = beta1(j, k) + exp(logbetasd) * randn;

            score1 = beta1(j, group1) + beta2(j, group2) + beta12(j, group12);
            newscore1 = newbeta1(group1) + beta2(j, group2) + beta12(j, group12);
            loglike = sum((s==j).*(group1==k)') * beta1(j, k) - J(j) * sum(v .* exp(score1));
            newloglike = sum((s==j).*(group1==k)') * newbeta1(k) - J(j) * sum(v .* exp(newscore1));
            
            loglike = loglike - 0.5 * beta1(j, k)^2 / sigmasq1;
            newloglike = newloglike - 0.5 * newbeta1(k)^2 / sigmasq1;
            
            logaccept = newloglike - loglike;
            accept = 1;
            if ( logaccept < 0 )
                accept = exp(logaccept);
            end
            
            if ( (isnan(logaccept) == 1) || (isinf(logaccept)==1) )
                accept = 0;
            end
            
            betaaccept = betaaccept + accept;
            betacount = betacount + 1;
            
            if ( rand < accept )
                beta1(j, k) = newbeta1(k);
            end
            
            logbetasd = logbetasd + 1 / it^(0.55) * (accept - 0.234);
        end
        
        for k = 1:ngroup2
            newbeta2 = beta2(j, :);
            newbeta2(k) = beta2(j, k) + exp(logbetasd) * randn;
            
            score1 = beta1(j, group1) + beta2(j, group2) + beta12(j, group12);
            newscore1 = beta1(j, group1) + newbeta2(group2) + beta12(j, group12);
            loglike = sum((s==j).*(group2==k)') * beta2(j, k) - J(j) * sum(v .* exp(score1));
            newloglike = sum((s==j).*(group2==k)') * newbeta2(k) - J(j) * sum(v .* exp(newscore1));

            loglike = loglike - 0.5 * beta2(j, k)^2 / sigmasq2;
            newloglike = newloglike - 0.5 * newbeta2(k)^2 / sigmasq2;
            
            logaccept = newloglike - loglike;
            accept = 1;
            if ( logaccept < 0 )
                accept = exp(logaccept);
            end
            
            if ( (isnan(logaccept) == 1) || (isinf(logaccept)==1) )
                accept = 0;
            end
            
            betaaccept = betaaccept + accept;
            betacount = betacount + 1;
            
            if ( rand < accept )
                beta2(j, k) = newbeta2(k);
            end
            
            logbetasd = logbetasd + 1 / it^(0.55) * (accept - 0.234);
        end
        
        for k1 = 1:ngroup1
            for k2 = 1:ngroup2
                k12 = ngroup2 * (k1 - 1) + k2;
                newbeta12 = beta12(j, :);
                newbeta12(k12) = beta12(j, k12) + exp(logbeta12sd) * randn;
                
                score1 = beta1(j, group1) + beta2(j, group2) + beta12(j, group12);
                newscore1 = beta1(j, group1) + beta2(j, group2) + newbeta12(group12);
                loglike = sum((s==j).*(group12==k12)') * beta12(j, k12) - J(j) * sum(v .* exp(score1));
                newloglike = sum((s==j).*(group12==k12)') * newbeta12(k12) - J(j) * sum(v .* exp(newscore1));
                
                loglike = loglike - 0.5 * beta12(j, k12)^2 / sigmasq_int;
                newloglike = newloglike - 0.5 * newbeta12(k12)^2 / sigmasq_int;
                
                logaccept = newloglike - loglike;
                accept = 1;
                if ( logaccept < 0 )
                    accept = exp(logaccept);
                end
                
                if ( (isnan(logaccept) == 1) || (isinf(logaccept)==1) )
                    accept = 0;
                end
                
                beta12accept = beta12accept + accept;
                beta12count = beta12count + 1;
                
                if ( rand < accept )
                    beta12(j, k12) = newbeta12(k12);
                end
                
                logbeta12sd = logbeta12sd + 1 / it^(0.55) * (accept - 0.234);
            end
        end
        
        
        newJ = J(j) * exp(exp(logJ1sd) * randn);
        
        loglike = - 0.5 * sum((beta1(j, :) + log(J(j)) - log(J(j))).^2) / sigmasq1 - J(j);
        newloglike = - 0.5 * sum((beta1(j, :) + log(J(j)) - log(newJ)).^2) / sigmasq1 - newJ;
        
        logaccept = newloglike - loglike;
        accept = 1;
        if ( isreal(logaccept) == 0 )
            accept = 0;
        elseif ( (isnan(logaccept) == 1) || (isinf(logaccept)==1) )
            accept = 0;
        elseif ( logaccept < 0 )
            accept = exp(logaccept);
        end
        
        J1accept = J1accept + accept;
        J1count = J1count + 1;
        
        if ( rand < accept )
            beta1(j, :) = beta1(j, :) + log(J(j)) - log(newJ);
            J(j) = newJ;
        end
        
        logJ1sd = logJ1sd + 1 / it^(0.55) * (accept - 0.234);

        
        
        newJ = J(j) * exp(exp(logJ2sd) * randn);
        
        loglike = - 0.5 * sum((beta2(j, :) + log(J(j)) - log(J(j))).^2) / sigmasq2 - J(j);
        newloglike = - 0.5 * sum((beta2(j, :) + log(J(j)) - log(newJ)).^2) / sigmasq2 - newJ;
        
        logaccept = newloglike - loglike;
        accept = 1;
        if ( isreal(logaccept) == 0 )
            accept = 0;
        elseif ( (isnan(logaccept) == 1) || (isinf(logaccept)==1) )
            accept = 0;
        elseif ( logaccept < 0 )
            accept = exp(logaccept);
        end
        
        J2accept = J2accept + accept;
        J2count = J2count + 1;
        
        if ( rand < accept )
            beta2(j, :) = beta2(j, :) + log(J(j)) - log(newJ);
            J(j) = newJ;
        end
        
        logJ2sd = logJ2sd + 1 / it^(0.55) * (accept - 0.234);

    
    
        newJ = J(j) * exp(exp(logJ12sd) * randn);
        
        loglike = - 0.5 * sum((beta12(j, :) + log(J(j)) - log(J(j))).^2) / sigmasq_int - J(j);
        newloglike = - 0.5 * sum((beta12(j, :) + log(J(j)) - log(newJ)).^2) / sigmasq_int - newJ;
        
        logaccept = newloglike - loglike;
        accept = 1;
        if ( isreal(logaccept) == 0 )
            accept = 0;
        elseif ( (isnan(logaccept) == 1) || (isinf(logaccept)==1) )
            accept = 0;
        elseif ( logaccept < 0 )
            accept = exp(logaccept);
        end
        
        J12accept = J12accept + accept;
        J12count = J12count + 1;
        
        if ( rand < accept )
            beta12(j, :) = beta12(j, :) + log(J(j)) - log(newJ);
            J(j) = newJ;
        end
        
        logJ12sd = logJ12sd + 1 / it^(0.55) * (accept - 0.234);
    end
    
    
    
    % Joint update v
    newv = v;
    
    newv(1) = v(1) * exp(exp(logvsd2) * randn);
    newv(2:end) = v(2:end) * newv(1) / v(1);
    newJ = J * v(1) / newv(1);
    
    K = poissrnd(a * M * newv * exp(0.5 * sigmasq1 + 0.5 * sigmasq2 + 0.5 * sigmasq_int) * (b - b * log(b) - log(b)));
        
    if ( sum(K) > Klimit )
        accept = 0;
    else       
        newlogtheta_comp = zeros(1, n);
        for j1 = 1:n
            newbetastar1{1, j1} = zeros(K(j1), ngroup1);
            newbetastar2{1, j1} = zeros(K(j1), ngroup2);
            newbetastar12{1, j1} = zeros(K(j1), ngroup1 * ngroup2);
            newJstar{1, j1} = zeros(1, K(j1));
            newfstar{1, j1} = zeros(1, K(j1));
            newgstar{1, j1} = zeros(1, K(j1));
            
            if ( K(j1) == 0 )
                newlogtheta_comp(j1) = 0;
            else
                newbetastar1{1, j1} = sqrt(sigmasq1) * randn(K(j1), ngroup1);
                newbetastar2{1, j1} = sqrt(sigmasq2) * randn(K(j1), ngroup2);
                newbetastar12{1, j1} = sqrt(sigmasq_int) * randn(K(j1), ngroup1 * ngroup2);

                newbetastar1{1, j1}(:, group1(j1)) = newbetastar1{1, j1}(:, group1(j1)) + sigmasq1;
                newbetastar2{1, j1}(:, group2(j1)) = newbetastar2{1, j1}(:, group2(j1)) + sigmasq2;
                newbetastar12{1, j1}(:, group12(j1)) = newbetastar12{1, j1}(:, group12(j1)) + sigmasq_int;
                       
                for k1 = 1:K(j1)
                    if ( rand < wstar2 )
                        z = - log(b) - 1;
                        while ( z < - log(b) )
                            z = gamrnd(2, 1);
                        end
                        newJstar{1, j1}(k1) = exp(- z);
                        newgstar{1, j1}(k1) = - log(newJstar{1, j1}(k1));
                    else
                        newJstar{1, j1}(k1) = b - log(rand);
                        newgstar{1, j1}(k1) = - log(b) * exp(- (newJstar{1, j1}(k1) - b));
                    end
                end
                score1 = newbetastar1{1, j1}(:, group1) + newbetastar2{1, j1}(:, group2) + newbetastar12{1, j1}(:, group12);
                x2 = exp(- newJstar{1, j1} .* (newv * exp(score1)'));                                    
                newfstar{1, j1} = expint(newJstar{1, j1});
                newlogtheta_comp(j1) = sum(log(1 - x2.*newfstar{1, j1}./(a*newgstar{1, j1})));
            end
        end
        newlogtheta = sum(newlogtheta_comp);
        
        loglike = logtheta;
        newloglike = newlogtheta;
        
        for j = 1:length(numb)
            score1 = beta1(j, group1) + beta2(j, group2) + beta12(j, group12);

            loglike = loglike - J(j) * sum(v .* exp(score1));
            newloglike = newloglike - newJ(j) * sum(newv .* exp(score1));
            
            loglike = loglike + (numb(j) - 1) * log(J(j)) - J(j);
            newloglike = newloglike + (numb(j) - 1) * log(newJ(j)) - newJ(j);
        end
        
        logaccept = newloglike - loglike;
        logaccept = logaccept + (n - length(numb)) * (log(newv(1)) - log(v(1)));
        
        accept = 1;
        if ( isreal(logaccept) == 0 )
            accept = 0;
        elseif ( (isnan(logaccept) == 1) || (isinf(logaccept)==1) )
            accept = 0;
        elseif ( logaccept < 0 )
            accept = exp(logaccept);
        end
    end
    
    if ( rand < accept )
        J = newJ;
        v = newv;
        logtheta = newlogtheta;
        logtheta_comp = newlogtheta_comp;
        betastar1 = newbetastar1;
        betastar2 = newbetastar2;
        betastar12 = newbetastar12;
        Jstar = newJstar;
        fstar = newfstar;
        gstar = newgstar;
        sumK = sum(K);
    end
    
    logvsd2 = logvsd2 + 1 / it^(0.55) * (accept - 0.234);
    
    vaccept2 = vaccept2 + accept;
    vcount2 = vcount2 + 1;
    
    
    
    
    
    % Update sigmasq1
    newsigmasq1 = sigmasq1 * exp(exp(logsigmasq1sd) * randn);

    K = poissrnd(a * M * v * exp(0.5 * newsigmasq1 + 0.5 * sigmasq2 + 0.5 * sigmasq_int) * (b - b * log(b) - log(b)));
    
    if ( sum(K) > Klimit )
        accept = 0;
    else
        newlogtheta_comp = zeros(1, n);
        for j1 = 1:n
            newbetastar1{1, j1} = zeros(K(j1), ngroup1);
            newbetastar2{1, j1} = zeros(K(j1), ngroup2);
            newbetastar12{1, j1} = zeros(K(j1), ngroup1 * ngroup2);
            newJstar{1, j1} = zeros(1, K(j1));
            newfstar{1, j1} = zeros(1, K(j1));
            newgstar{1, j1} = zeros(1, K(j1));
            if ( K(j1) == 0 )
                newlogtheta_comp(j1) = 0;
            else
                newbetastar1{1, j1} = sqrt(newsigmasq1) * randn(K(j1), ngroup1);
                newbetastar2{1, j1} = sqrt(sigmasq2) * randn(K(j1), ngroup2);
                newbetastar12{1, j1} = sqrt(sigmasq_int) * randn(K(j1), ngroup1 * ngroup2);
                newbetastar1{1, j1}(:, group1(j1)) = newbetastar1{1, j1}(:, group1(j1)) + newsigmasq1;
                newbetastar2{1, j1}(:, group2(j1)) = newbetastar2{1, j1}(:, group2(j1)) + sigmasq2;
                newbetastar12{1, j1}(:, group12(j1)) = newbetastar12{1, j1}(:, group12(j1)) + sigmasq_int;
                
                for k1 = 1:K(j1)
                    if ( rand < wstar2 )
                        z = - log(b) - 1;
                        while ( z < - log(b) )
                            z = gamrnd(2, 1);
                        end
                        newJstar{1, j1}(k1) = exp(- z);
                        newgstar{1, j1}(k1) = - log(newJstar{1, j1}(k1));
                    else
                        newJstar{1, j1}(k1) = b - log(rand);
                        newgstar{1, j1}(k1) = - log(b) * exp(- (newJstar{1, j1}(k1) - b));
                    end
                end
                score1 = newbetastar1{1, j1}(:, group1) + newbetastar2{1, j1}(:, group2) + newbetastar12{1, j1}(:, group12);
                x2 = exp(- newJstar{1, j1} .* (v * exp(score1)'));
                newfstar{1, j1} = expint(newJstar{1, j1});
                newlogtheta_comp(j1) = sum(log(1 - x2.*newfstar{1, j1}./(a*newgstar{1, j1})));
            end
        end
        newlogtheta = sum(newlogtheta_comp);
        
        newloglike = newlogtheta;
        loglike = logtheta;
        
        loglike = loglike - 0.5 * sum(sum(beta1.^2)) / sigmasq1 - 0.5 * ngroup1 * length(numb) * log(sigmasq1);
        newloglike = newloglike - 0.5 * sum(sum(beta1.^2)) / newsigmasq1 - 0.5 * ngroup1 * length(numb) * log(newsigmasq1);
                
        logaccept = newloglike - loglike;
        logaccept = logaccept + log(newsigmasq1) - log(sigmasq1) - 2 * (newsigmasq1 - sigmasq1);
        
        accept = 1;
        if ( isreal(logaccept) == 0 )
            accept = 0;
        elseif ( (isnan(logaccept) == 1) || (isinf(logaccept)==1) )
            accept = 0;
        elseif ( logaccept < 0 )
            accept = exp(logaccept);
        end
    end

    
    if ( rand < accept )
        sigmasq1 = newsigmasq1;
        logtheta = newlogtheta;
        logtheta_comp = newlogtheta_comp;
        betastar1 = newbetastar1;
        betastar2 = newbetastar2;
        betastar12 = newbetastar12;
        Jstar = newJstar;
        fstar = newfstar;
        gstar = newgstar;
        sumK = sum(K);
    end
    
    logsigmasq1sd = logsigmasq1sd + 1 / it^(0.55) * (accept - 0.234);
    
    sigmasq1accept = sigmasq1accept + accept;
    sigmasq1count = sigmasq1count + 1;

    
    
    
    % Update sigmasq1
    newsigmasq1 = sigmasq1 * exp(exp(logsigmasq1sd2) * randn);
    
    K = poissrnd(a * M * v * exp(0.5 * newsigmasq1 + 0.5 * sigmasq2 + 0.5 * sigmasq_int) * (b - b * log(b) - log(b)));
    
    if ( sum(K) > Klimit )
        accept = 0;
    else
        newlogtheta_comp = zeros(1, n);
        for j1 = 1:n
            newbetastar1{1, j1} = zeros(K(j1), ngroup1);
            newbetastar2{1, j1} = zeros(K(j1), ngroup2);
            newbetastar12{1, j1} = zeros(K(j1), ngroup1 * ngroup2);
            newJstar{1, j1} = zeros(1, K(j1));
            newfstar{1, j1} = zeros(1, K(j1));
            newgstar{1, j1} = zeros(1, K(j1));
            if ( K(j1) == 0 )
                newlogtheta_comp(j1) = 0;
            else
                newbetastar1{1, j1} = sqrt(newsigmasq1) * randn(K(j1), ngroup1);
                newbetastar2{1, j1} = sqrt(sigmasq2) * randn(K(j1), ngroup2);
                newbetastar12{1, j1} = sqrt(sigmasq_int) * randn(K(j1), ngroup1 * ngroup2);
                newbetastar1{1, j1}(:, group1(j1)) = newbetastar1{1, j1}(:, group1(j1)) + newsigmasq1;
                newbetastar2{1, j1}(:, group2(j1)) = newbetastar2{1, j1}(:, group2(j1)) + sigmasq2;
                newbetastar12{1, j1}(:, group12(j1)) = newbetastar12{1, j1}(:, group12(j1)) + sigmasq_int;
                
                for k1 = 1:K(j1)
                    if ( rand < wstar2 )
                        z = - log(b) - 1;
                        while ( z < - log(b) )
                            z = gamrnd(2, 1);
                        end
                        newJstar{1, j1}(k1) = exp(- z);
                        newgstar{1, j1}(k1) = - log(newJstar{1, j1}(k1));
                    else
                        newJstar{1, j1}(k1) = b - log(rand);
                        newgstar{1, j1}(k1) = - log(b) * exp(- (newJstar{1, j1}(k1) - b));
                    end
                end
                score1 = newbetastar1{1, j1}(:, group1) + newbetastar2{1, j1}(:, group2) + newbetastar12{1, j1}(:, group12);
                x2 = exp(- newJstar{1, j1} .* (v * exp(score1)'));
                newfstar{1, j1} = expint(newJstar{1, j1});
                newlogtheta_comp(j1) = sum(log(1 - x2.*newfstar{1, j1}./(a*newgstar{1, j1})));
            end
        end
        newlogtheta = sum(newlogtheta_comp);
        
        newloglike = newlogtheta;
        loglike = logtheta;
        
        newbeta1 = beta1;
        for j1 = 1:length(numb)
            newbeta1(j1, :) = beta1(j1, :) * sqrt(newsigmasq1 / sigmasq1);
            
            score1 = beta1(j1, group1) + beta2(j1, group2) + beta12(j1, group12);
            newscore1 = newbeta1(j1, group1) + beta2(j1, group2) + beta12(j1, group12);
            
            loglike = loglike - J(j1) * sum(v .* exp(score1));
            newloglike = newloglike - J(j1) * sum(v .* exp(newscore1));
            
            loglike = loglike + sum(beta1(j1, group1(s==j1)));
            newloglike = newloglike + sum(newbeta1(j1, group1(s==j1)));
        end
        
        logaccept = newloglike - loglike;
        logaccept = logaccept + log(newsigmasq1) - log(sigmasq1) - 2 * (newsigmasq1 - sigmasq1);
        
        accept = 1;
        if ( isreal(logaccept) == 0 )
            accept = 0;
        elseif ( (isnan(logaccept) == 1) || (isinf(logaccept)==1) )
            accept = 0;
        elseif ( logaccept < 0 )
            accept = exp(logaccept);
        end
    end
    
    
    if ( rand < accept )
        sigmasq1 = newsigmasq1;
        beta1 = newbeta1;
        logtheta = newlogtheta;
        logtheta_comp = newlogtheta_comp;
        betastar1 = newbetastar1;
        betastar2 = newbetastar2;
        betastar12 = newbetastar12;
        Jstar = newJstar;
        fstar = newfstar;
        gstar = newgstar;
        sumK = sum(K);
    end
    
    logsigmasq1sd2 = logsigmasq1sd2 + 1 / it^(0.55) * (accept - 0.234);
    
    sigmasq1accept2 = sigmasq1accept2 + accept;
    sigmasq1count2 = sigmasq1count2 + 1;
    
    
    
    
    
    
    
    
    
    % Update sigmasq2
    newsigmasq2 = sigmasq2 * exp(exp(logsigmasq2sd) * randn);

    K = poissrnd(a * M * v * exp(0.5 * sigmasq1 + 0.5 * newsigmasq2 + 0.5 * sigmasq_int) * (b - b * log(b) - log(b)));
    
    if ( sum(K) > Klimit )
        accept = 0;
    else
        newlogtheta_comp = zeros(1, n);
        for j1 = 1:n
            newbetastar1{1, j1} = zeros(K(j1), ngroup1);
            newbetastar2{1, j1} = zeros(K(j1), ngroup2);
            newbetastar12{1, j1} = zeros(K(j1), ngroup1 * ngroup2);
            newJstar{1, j1} = zeros(1, K(j1));
            newfstar{1, j1} = zeros(1, K(j1));
            newgstar{1, j1} = zeros(1, K(j1));
            if ( K(j1) == 0 )
                newlogtheta_comp(j1) = 0;
            else
                newbetastar1{1, j1} = sqrt(sigmasq1) * randn(K(j1), ngroup1);
                newbetastar2{1, j1} = sqrt(newsigmasq2) * randn(K(j1), ngroup2);
                newbetastar12{1, j1} = sqrt(sigmasq_int) * randn(K(j1), ngroup1 * ngroup2);
                newbetastar1{1, j1}(:, group1(j1)) = newbetastar1{1, j1}(:, group1(j1)) + sigmasq1;
                newbetastar2{1, j1}(:, group2(j1)) = newbetastar2{1, j1}(:, group2(j1)) + newsigmasq2;
                newbetastar12{1, j1}(:, group12(j1)) = newbetastar12{1, j1}(:, group12(j1)) + sigmasq_int;
                
                for k1 = 1:K(j1)
                    if ( rand < wstar2 )
                        z = - log(b) - 1;
                        while ( z < - log(b) )
                            z = gamrnd(2, 1);
                        end
                        newJstar{1, j1}(k1) = exp(- z);
                        newgstar{1, j1}(k1) = - log(newJstar{1, j1}(k1));
                    else
                        newJstar{1, j1}(k1) = b - log(rand);
                        newgstar{1, j1}(k1) = - log(b) * exp(- (newJstar{1, j1}(k1) - b));
                    end
                end
                score1 = newbetastar1{1, j1}(:, group1) + newbetastar2{1, j1}(:, group2) + newbetastar12{1, j1}(:, group12);
                x2 = exp(- newJstar{1, j1} .* (v * exp(score1)'));
                newfstar{1, j1} = expint(newJstar{1, j1});
                newlogtheta_comp(j1) = sum(log(1 - x2.*newfstar{1, j1}./(a*newgstar{1, j1})));
            end
        end
        newlogtheta = sum(newlogtheta_comp);
        
        newloglike = newlogtheta;
        loglike = logtheta;
                
        loglike = loglike - 0.5 * sum(sum(beta2.^2)) / sigmasq2 - 0.5 * ngroup2 * length(numb) * log(sigmasq2);
        newloglike = newloglike - 0.5 * sum(sum(beta2.^2)) / newsigmasq2 - 0.5 * ngroup2 * length(numb) * log(newsigmasq2);
        
        logaccept = newloglike - loglike;
        logaccept = logaccept + log(newsigmasq2) - log(sigmasq2) - 2 * (newsigmasq2 - sigmasq2);
        
        accept = 1;
        if ( isreal(logaccept) == 0 )
            accept = 0;
        elseif ( (isnan(logaccept) == 1) || (isinf(logaccept)==1) )
            accept = 0;
        elseif ( logaccept < 0 )
            accept = exp(logaccept);
        end
    end

    
    if ( rand < accept )
        sigmasq2 = newsigmasq2;
        logtheta = newlogtheta;
        logtheta_comp = newlogtheta_comp;
        betastar1 = newbetastar1;
        betastar2 = newbetastar2;
        betastar12 = newbetastar12;
        Jstar = newJstar;
        fstar = newfstar;
        gstar = newgstar;
        sumK = sum(K);
    end
    
    logsigmasq2sd = logsigmasq2sd + 1 / it^(0.55) * (accept - 0.234);
    
    sigmasq2accept = sigmasq2accept + accept;
    sigmasq2count = sigmasq2count + 1;
    
    


    
    
    
    % Update sigmasq2
    newsigmasq2 = sigmasq2 * exp(exp(logsigmasq2sd2) * randn);
    
    K = poissrnd(a * M * v * exp(0.5 * sigmasq1 + 0.5 * newsigmasq2 + 0.5 * sigmasq_int) * (b - b * log(b) - log(b)));
    
    if ( sum(K) > Klimit )
        accept = 0;
    else
        newlogtheta_comp = zeros(1, n);
        for j1 = 1:n
            newbetastar1{1, j1} = zeros(K(j1), ngroup1);
            newbetastar2{1, j1} = zeros(K(j1), ngroup2);
            newbetastar12{1, j1} = zeros(K(j1), ngroup1 * ngroup2);
            newJstar{1, j1} = zeros(1, K(j1));
            newfstar{1, j1} = zeros(1, K(j1));
            newgstar{1, j1} = zeros(1, K(j1));
            if ( K(j1) == 0 )
                newlogtheta_comp(j1) = 0;
            else
                newbetastar1{1, j1} = sqrt(sigmasq1) * randn(K(j1), ngroup1);
                newbetastar2{1, j1} = sqrt(newsigmasq2) * randn(K(j1), ngroup2);
                newbetastar12{1, j1} = sqrt(sigmasq_int) * randn(K(j1), ngroup1 * ngroup2);
                newbetastar1{1, j1}(:, group1(j1)) = newbetastar1{1, j1}(:, group1(j1)) + sigmasq1;
                newbetastar2{1, j1}(:, group2(j1)) = newbetastar2{1, j1}(:, group2(j1)) + newsigmasq2;
                newbetastar12{1, j1}(:, group12(j1)) = newbetastar12{1, j1}(:, group12(j1)) + sigmasq_int;
                
                for k1 = 1:K(j1)
                    if ( rand < wstar2 )
                        z = - log(b) - 1;
                        while ( z < - log(b) )
                            z = gamrnd(2, 1);
                        end
                        newJstar{1, j1}(k1) = exp(- z);
                        newgstar{1, j1}(k1) = - log(newJstar{1, j1}(k1));
                    else
                        newJstar{1, j1}(k1) = b - log(rand);
                        newgstar{1, j1}(k1) = - log(b) * exp(- (newJstar{1, j1}(k1) - b));
                    end
                end
                score1 = newbetastar1{1, j1}(:, group1) + newbetastar2{1, j1}(:, group2) + newbetastar12{1, j1}(:, group12);
                x2 = exp(- newJstar{1, j1} .* (v * exp(score1)'));
                newfstar{1, j1} = expint(newJstar{1, j1});
                newlogtheta_comp(j1) = sum(log(1 - x2.*newfstar{1, j1}./(a*newgstar{1, j1})));
            end
        end
        newlogtheta = sum(newlogtheta_comp);
        
        newloglike = newlogtheta;
        loglike = logtheta;
        
        newbeta2 = beta2;
        for j1 = 1:length(numb)
            newbeta2(j1, :) = beta2(j1, :) * sqrt(newsigmasq2 / sigmasq2);
            
            score1 = beta1(j1, group1) + beta2(j1, group2) + beta12(j1, group12);
            newscore1 = beta1(j1, group1) + newbeta2(j1, group2) + beta12(j1, group12);
            
            loglike = loglike - J(j1) * sum(v .* exp(score1));
            newloglike = newloglike - J(j1) * sum(v .* exp(newscore1));
            
            loglike = loglike + sum(beta2(j1, group2(s==j1)));
            newloglike = newloglike + sum(newbeta2(j1, group2(s==j1)));
        end
        
        logaccept = newloglike - loglike;
        logaccept = logaccept + log(newsigmasq2) - log(sigmasq2) - 2 * (newsigmasq2 - sigmasq2);
        
        accept = 1;
        if ( isreal(logaccept) == 0 )
            accept = 0;
        elseif ( (isnan(logaccept) == 1) || (isinf(logaccept)==1) )
            accept = 0;
        elseif ( logaccept < 0 )
            accept = exp(logaccept);
        end
    end
    
    
    if ( rand < accept )
        sigmasq2 = newsigmasq2;
        beta2 = newbeta2;
        logtheta = newlogtheta;
        logtheta_comp = newlogtheta_comp;
        betastar1 = newbetastar1;
        betastar2 = newbetastar2;
        betastar12 = newbetastar12;
        Jstar = newJstar;
        fstar = newfstar;
        gstar = newgstar;
        sumK = sum(K);
    end
    
    logsigmasq2sd2 = logsigmasq2sd2 + 1 / it^(0.55) * (accept - 0.234);
    
    sigmasq2accept2 = sigmasq2accept2 + accept;
    sigmasq2count2 = sigmasq2count2 + 1;
    
    
    
    
    
    
    
    
    
    
    
    % Update sigmasq_int
    newsigmasq_int = sigmasq_int * exp(exp(logsigmasq_intsd) * randn);
    
    K = poissrnd(a * M * v * exp(0.5 * sigmasq1 + 0.5 * sigmasq2 + 0.5 * newsigmasq_int) * (b - b * log(b) - log(b)));
    
    if ( sum(K) > Klimit )
        accept = 0;
    else
        newlogtheta_comp = zeros(1, n);
        for j1 = 1:n
            newbetastar1{1, j1} = zeros(K(j1), ngroup1);
            newbetastar2{1, j1} = zeros(K(j1), ngroup2);
            newbetastar12{1, j1} = zeros(K(j1), ngroup1 * ngroup2);
            newJstar{1, j1} = zeros(1, K(j1));
            newfstar{1, j1} = zeros(1, K(j1));
            newgstar{1, j1} = zeros(1, K(j1));
            if ( K(j1) == 0 )
                newlogtheta_comp(j1) = 0;
            else
                newbetastar1{1, j1} = sqrt(sigmasq1) * randn(K(j1), ngroup1);
                newbetastar2{1, j1} = sqrt(sigmasq2) * randn(K(j1), ngroup2);
                newbetastar12{1, j1} = sqrt(newsigmasq_int) * randn(K(j1), ngroup1 * ngroup2);
                newbetastar1{1, j1}(:, group1(j1)) = newbetastar1{1, j1}(:, group1(j1)) + sigmasq1;
                newbetastar2{1, j1}(:, group2(j1)) = newbetastar2{1, j1}(:, group2(j1)) + sigmasq2;
                newbetastar12{1, j1}(:, group12(j1)) = newbetastar12{1, j1}(:, group12(j1)) + newsigmasq_int;
                
                for k1 = 1:K(j1)
                    if ( rand < wstar2 )
                        z = - log(b) - 1;
                        while ( z < - log(b) )
                            z = gamrnd(2, 1);
                        end
                        newJstar{1, j1}(k1) = exp(- z);
                        newgstar{1, j1}(k1) = - log(newJstar{1, j1}(k1));
                    else
                        newJstar{1, j1}(k1) = b - log(rand);
                        newgstar{1, j1}(k1) = - log(b) * exp(- (newJstar{1, j1}(k1) - b));
                    end
                end
                score1 = newbetastar1{1, j1}(:, group1) + newbetastar2{1, j1}(:, group2) + newbetastar12{1, j1}(:, group12);
                x2 = exp(- newJstar{1, j1} .* (v * exp(score1)'));
                newfstar{1, j1} = expint(newJstar{1, j1});
                newlogtheta_comp(j1) = sum(log(1 - x2.*newfstar{1, j1}./(a*newgstar{1, j1})));
            end
        end
        newlogtheta = sum(newlogtheta_comp);
        
        newloglike = newlogtheta;
        loglike = logtheta;
        
        loglike = loglike - 0.5 * sum(sum(beta12.^2)) / sigmasq_int - 0.5 * ngroup1 * ngroup2 * length(numb) * log(sigmasq_int);
        newloglike = newloglike - 0.5 * sum(sum(beta12.^2)) / newsigmasq_int - 0.5 * ngroup1 * ngroup2 * length(numb) * log(newsigmasq_int);
        
        logaccept = newloglike - loglike;
        logaccept = logaccept + log(newsigmasq_int) - log(sigmasq_int) - 2 * (newsigmasq_int - sigmasq_int);
        
        accept = 1;
        if ( isreal(logaccept) == 0 )
            accept = 0;
        elseif ( (isnan(logaccept) == 1) || (isinf(logaccept)==1) )
            accept = 0;
        elseif ( logaccept < 0 )
            accept = exp(logaccept);
        end
    end
    
    if ( rand < accept )
        sigmasq_int = newsigmasq_int;
        logtheta = newlogtheta;
        logtheta_comp = newlogtheta_comp;
        betastar1 = newbetastar1;
        betastar2 = newbetastar2;
        betastar12 = newbetastar12;
        Jstar = newJstar;
        fstar = newfstar;
        gstar = newgstar;
        sumK = sum(K);
    end
    
    logsigmasq_intsd = logsigmasq_intsd + 1 / it^(0.55) * (accept - 0.234);
    
    sigmasq_intaccept = sigmasq_intaccept + accept;
    sigmasq_intcount = sigmasq_intcount + 1;
    
    
     
    
    % Update sigmasq_int
    newsigmasq_int = sigmasq_int * exp(exp(logsigmasq_intsd2) * randn);
    
    K = poissrnd(a * M * v * exp(0.5 * sigmasq1 + 0.5 * sigmasq2 + 0.5 * newsigmasq_int) * (b - b * log(b) - log(b)));
    
    if ( sum(K) > Klimit )
        accept = 0;
    else
        newlogtheta_comp = zeros(1, n);
        for j1 = 1:n
            newbetastar1{1, j1} = zeros(K(j1), ngroup1);
            newbetastar2{1, j1} = zeros(K(j1), ngroup2);
            newbetastar12{1, j1} = zeros(K(j1), ngroup1 * ngroup2);
            newJstar{1, j1} = zeros(1, K(j1));
            newfstar{1, j1} = zeros(1, K(j1));
            newgstar{1, j1} = zeros(1, K(j1));
            if ( K(j1) == 0 )
                newlogtheta_comp(j1) = 0;
            else
                newbetastar1{1, j1} = sqrt(sigmasq1) * randn(K(j1), ngroup1);
                newbetastar2{1, j1} = sqrt(sigmasq2) * randn(K(j1), ngroup2);
                newbetastar12{1, j1} = sqrt(newsigmasq_int) * randn(K(j1), ngroup1 * ngroup2);
                newbetastar1{1, j1}(:, group1(j1)) = newbetastar1{1, j1}(:, group1(j1)) + sigmasq1;
                newbetastar2{1, j1}(:, group2(j1)) = newbetastar2{1, j1}(:, group2(j1)) + sigmasq2;
                newbetastar12{1, j1}(:, group12(j1)) = newbetastar12{1, j1}(:, group12(j1)) + newsigmasq_int;
                
                for k1 = 1:K(j1)
                    if ( rand < wstar2 )
                        z = - log(b) - 1;
                        while ( z < - log(b) )
                            z = gamrnd(2, 1);
                        end
                        newJstar{1, j1}(k1) = exp(- z);
                        newgstar{1, j1}(k1) = - log(newJstar{1, j1}(k1));
                    else
                        newJstar{1, j1}(k1) = b - log(rand);
                        newgstar{1, j1}(k1) = - log(b) * exp(- (newJstar{1, j1}(k1) - b));
                    end
                end
                score1 = newbetastar1{1, j1}(:, group1) + newbetastar2{1, j1}(:, group2) + newbetastar12{1, j1}(:, group12);
                x2 = exp(- newJstar{1, j1} .* (v * exp(score1)'));
                newfstar{1, j1} = expint(newJstar{1, j1});
                newlogtheta_comp(j1) = sum(log(1 - x2.*newfstar{1, j1}./(a*newgstar{1, j1})));
            end
        end
        newlogtheta = sum(newlogtheta_comp);
        
        newloglike = newlogtheta;
        loglike = logtheta;
        
        newbeta12 = beta12;
        for j1 = 1:length(numb)
            newbeta12(j1, :) = beta12(j1, :) * sqrt(newsigmasq_int / sigmasq_int);
            
            score1 = beta1(j1, group1) + beta2(j1, group2) + beta12(j1, group12);
            newscore1 = beta1(j1, group1) + beta2(j1, group2) + newbeta12(j1, group12);
            
            loglike = loglike - J(j1) * sum(v .* exp(score1));
            newloglike = newloglike - J(j1) * sum(v .* exp(newscore1));
            
            loglike = loglike + sum(beta12(j1, group12(s==j1)));
            newloglike = newloglike + sum(newbeta12(j1, group12(s==j1)));
        end
        
        logaccept = newloglike - loglike;
        logaccept = logaccept + log(newsigmasq_int) - log(sigmasq_int) - 2 * (newsigmasq_int- sigmasq_int);
        
        accept = 1;
        if ( isreal(logaccept) == 0 )
            accept = 0;
        elseif ( (isnan(logaccept) == 1) || (isinf(logaccept)==1) )
            accept = 0;
        elseif ( logaccept < 0 )
            accept = exp(logaccept);
        end
    end
    
    
    if ( rand < accept )
        sigmasq_int = newsigmasq_int;
        beta12 = newbeta12;
        logtheta = newlogtheta;
        logtheta_comp = newlogtheta_comp;
        betastar1 = newbetastar1;
        betastar2 = newbetastar2;
        betastar12 = newbetastar12;
        Jstar = newJstar;
        fstar = newfstar;
        gstar = newgstar;
        sumK = sum(K);
    end
    
    logsigmasq_intsd2 = logsigmasq_intsd2 + 1 / it^(0.55) * (accept - 0.234);
    
    sigmasq_intaccept2 = sigmasq_intaccept2 + accept;
    sigmasq_intcount2 = sigmasq_intcount2 + 1;
    
    
    
    
    
    
    
    
    
    
    % Update M
    newM = M * exp(exp(logMsd) * randn);
    
    K = poissrnd(a * newM * v * exp(0.5 * sigmasq1 + 0.5 * sigmasq2 + 0.5 * sigmasq_int) * (b - b * log(b) - log(b)));
    
    if ( sum(K) > Klimit )
        accept = 0;
    else
        newlogtheta_comp = zeros(1, n);
        for i = 1:n
            newbetastar1{1, i} = zeros(K(i), ngroup1);
            newbetastar2{1, i} = zeros(K(i), ngroup2);
            newbetastar12{1, i} = zeros(K(i), ngroup1 * ngroup2);
            newJstar{1, i} = zeros(1, K(i));
            newfstar{1, i} = zeros(1, K(i));
            newgstar{1, i} = zeros(1, K(i));
            x2 = zeros(1, K(i));
            
            if ( K(i) == 0 )
                newlogtheta_comp(i) = 0;
            else
                newbetastar1{1, i} = sqrt(sigmasq1) * randn(K(i), ngroup1);
                newbetastar2{1, i} = sqrt(sigmasq2) * randn(K(i), ngroup2);
                newbetastar12{1, i} = sqrt(sigmasq_int) * randn(K(i), ngroup1 * ngroup2);
                newbetastar1{1, i}(:, group1(i)) = newbetastar1{1, i}(:, group1(i)) + sigmasq1;
                newbetastar2{1, i}(:, group2(i)) = newbetastar2{1, i}(:, group2(i)) + sigmasq2;
                newbetastar12{1, i}(:, group12(i)) = newbetastar12{1, i}(:, group12(i)) + sigmasq_int;
      
                for k1 = 1:K(i)
                    if ( rand < wstar2 )
                        z = - log(b) - 1;
                        while ( z < - log(b) )
                            z = gamrnd(2, 1);
                        end
                        newJstar{1, i}(k1) = exp(- z);
                        newgstar{1, i}(k1) = - log(newJstar{1, i}(k1));
                    else
                        newJstar{1, i}(k1) = b - log(rand);
                        newgstar{1, i}(k1) = - log(b) * exp(- (newJstar{1, i}(k1) - b));
                    end
                end
                score1 = newbetastar1{1, i}(:, group1) + newbetastar2{1, i}(:, group2) + newbetastar12{1, i}(:, group12);
                x2 = exp(- newJstar{1, i} .* (v * exp(score1)'));                                    
                newfstar{1, i} = expint(newJstar{1, i});
                newlogtheta_comp(i) = sum(log(1 - x2.*newfstar{1, i}./(a*newgstar{1, i})));
            end
        end
        newlogtheta = sum(newlogtheta_comp);
        
        newloglike = newlogtheta + length(numb) * log(newM);
        loglike = logtheta + length(numb) * log(M);
        
        logaccept = newloglike - loglike;
        logaccept = logaccept + log(newM) - log(M) - (newM - M);
        
        accept = 1;
        if ( isreal(logaccept) == 0 )
            accept = 0;
        elseif ( (isnan(logaccept) == 1) || (isinf(logaccept)==1) )       
            accept = 0;
        elseif ( logaccept < 0 )
            accept = exp(logaccept);
        end
    end
    
    if ( rand < accept )
        M = newM;
        logtheta = newlogtheta;
        logtheta_comp = newlogtheta_comp;
        betastar1 = newbetastar1;
        betastar2 = newbetastar2;
        betastar12 = newbetastar12;
        Jstar = newJstar;
        fstar = newfstar;
        gstar = newgstar;
        sumK = sum(K);
    end
    
    logMsd = logMsd + 1 / it^(0.55) * (accept - 0.234);
    
    Maccept = Maccept + accept;
    Mcount = Mcount + 1;
    
    
    

    
    if ( it > burnin )
        if ( mod(it - burnin, every) == 0 )
            numbclust((it - burnin) / every) = length(unique(s));
            holdsigmasq1((it - burnin) / every) = sigmasq1;
            holdsigmasq2((it - burnin) / every) = sigmasq2;
            holdsigmasq_int((it - burnin) / every) = sigmasq_int;
            holdv((it - burnin) / every, :) = v;
            holdM((it - burnin) / every) = M;

            Sigma = zeros(p, p, length(numb));
            mu = zeros(p, length(numb));
            for comp = 1:length(numb)
                a1 = nu + numb(comp);
                submat1 = (sum1(:, comp) + lambda_prior * mu0') * (sum1(:, comp) + lambda_prior * mu0')';
                                
                b1 = Psi_prior + sum2(:, :, comp) + lambda_prior * (mu0' * mu0) - submat1 / (numb(comp) + lambda_prior);
                
                b1 = (b1 + b1') / 2;
                
                Sigma(:, :, comp) = inv(wishrnd(inv(b1), a1));
                
                mean1 = (sum1(:, comp) + lambda_prior * mu0') / (numb(comp) + lambda_prior);
                var1 = Sigma(:, :, comp) / (numb(comp) + lambda_prior);
                
                mu(:, comp) = mean1 + chol(var1)' * randn(p, 1);
            end
            
            Astar = zeros(1, size(ypred, 2), 1);
            for m = 1:p
                for i1 = 1:ngroup1
                    for i2 = 1:ngroup2
                        k = (i1 - 1) * ngroup2 + i2;
                        score1 = beta1(:, i1) + beta2(:, i2) + beta12(:, (i1 - 1) * ngroup2 + i2);
                        probstar = J .* exp(score1) / sum(J .* exp(score1));
                        for comp = 1:length(numb)
                            Astar(1, :, 1) = probstar(comp) * exp(- 0.5 * log(2 * pi * Sigma(m, m, comp)) - 0.5 * (ypred(m, :) - mu(m, comp)).^2 / Sigma(m, m, comp));
                            fpred(m, :, k) = fpred(m, :, k) + Astar;
                        end
                    end
                end
            end
        end
    end
end

fpred = fpred / numbofits;


